<template>
  <div>
    <div class="row d-flex justify-content-between">
      <div class="col text-md-end order-2">
        <!--
        <button v-if="!esAlta" type="button" class="btn btn-secondary mt-4 p-1 px-2 mx-2 text-uppercase"
          alt="Exportar a PDF" title="Exportar a PDF" @click="exportar('.pdf')">
          <i class="bi bi-filetype-pdf fonts-sm"></i>
        </button>
        <button v-if="!esAlta" type="button" class="btn btn-secondary mt-4 p-1 px-2 mx-2 text-uppercase"
          alt="Exportar a Excel" title="Exportar a Excel" @click="exportar('.xls')">
          <i class="bi bi-file-earmark-spreadsheet fonts-sm"></i>
        </button>
      -->
        <button v-if="!esAlta" type="button" class="btn mt-1 p-1 px-2 mx-2 btn-crear" alt="Imprimir solicitud"
          title="Imprimir solicitud de beca" @click="exportar()">
          <i class="fa-solid fa-file-pdf fs-7"></i> Imprimir solicitud
        </button>
        <button v-if="!esAlta" type="button" class="btn btn-correcto mt-1 p-1 px-2 mx-2" alt="Visado de beca"
          title="Visado de beca" @click="abrirVisado()">
          <i class="fa-solid fa-square-check me-1 fs-7"></i> Visado
        </button>
        <Modal ref="visadoModal" :size="'lg'" :title="visadoTitulo">
          <VisadoModal :beca="form.beca" :titulo="form.titulo" :mes-certif="form.mesCertif" :es-opcion-abm="esOpcionAbm"
            @cerrar="cerrarVisado">
          </VisadoModal>
        </Modal>
        <button v-show="cargaBloquesInhabilitada != 1 || usuarioActivoIdPerfil != 3" v-if="verModificar" :disabled="/* !esHabilitadoModificar */ false"  type="button"
          class="btn btn-guardar mt-1 mx-2 fs-3" alt="Guardar beca" title="Guardar beca" @click="inicioValidar()">
          <i class="fa-solid fa-floppy-disk "></i>
        </button>

        <button v-if="verEliminar" :disabled="/* !esHabilitadoEliminar */ false" type="button"
          class="btn btn-borrar mt-1 mx-2 text-uppercase p-0 px-2 fs-5" alt="Eliminar beca" title="Eliminar beca"
          @click="eliminarOEditar()">
          <i class="fa-solid fa-trash-can"></i>
        </button>

      </div>

      <div class="col row order-1 fs-9">
        <fieldset class="col pt-0">
          <div class="row">
            <div class="col-2 mt-1">
              <b>Solicitante:</b> {{ form.solicitante?.ayn }}
            </div>
            <div class="col mt-1">
              <b>Cargo: </b>{{ form.solicitante?.d_cargo }}
            </div>
            <div class="col mt-1">
              <b>Dependencia: </b>{{ form.solicitante?.d_dependen }}
            </div>

            <div class="col mt-1">
              <span v-if="haySeccionSolicitante">
                <b>Secci&oacute;n electoral: </b>{{ form.solicitante?.sec_electoral }}
              </span>
            </div>
            <div class="col mt-1">
              <b>C&oacute;d. Safin: </b>{{ form.solicitante?.cod_safin }}
            </div>
            <div class="col-2 mt-1" v-if='haySolicitante'>
              <p v-if='haySolicTotalDisp === false' class="text-danger"
                v-html='"El solicitante no tiene cupo disponible"'>
              </p>
              <p v-if='haySolicTotalDisp === true' class="text-success"
                v-html='"Cupo disponible del solicitante: " + importeMostrar(form.solicitante?.tot_disponible)'></p>
                <h3 v-show='cargaBloquesInhabilitada == 1' class="text-danger" v-html='"CARGA INHABILITADA"'></h3>
            </div>
            <div class="col-2 mt-1">
              <button type="button" class="btn btn-principal px-2 mt-1" alt="Ver cupos activos del solicitante"
                title="Ver cupos activos del solicitante" @click="verCupos()">
                Ver cupos
              </button>
              <Modal ref="cuposModal" :size="'lg'" :title="cuposTitulo">
                <CuposModal :parametros="cuposParametros"></CuposModal>
              </Modal>
            </div>
          </div>
        </fieldset>
      </div>
    </div>
    <div class="row mt-2 mb-1">
      <PanelBecario class="col-md-6 p-4" v-model='form.becario' :id-perfil-usuario='idPerfilUsuario' :id-beca='idBeca'
        :es-becario='true' :es-misma-seccion='esBecarioMismaSeccion' :es-doc-habilitado='esDocHabilitado'
        :es-apoderado-oblig='esApoderadoOblig' :es-bec-y-apod-iguales='esBecYApodIguales' :hay-bec-o-apod='hayApoderado'
        :inicio-validar='validarBecario.inicio' :inicio-guardar='guardarBecario.inicio'
        :inicio-revertir='revertirBecario.inicio' @act-hay-becario='actualizarHayBecOApod'
        @fin-validar='finValidarBecOApod' @fin-guardar='finGuardarBecOApod' @fin-revertir='finRevertirBecOApod'
        ref="panelBecario" />
      <PanelBecario class="col-md-6 p-4" v-model='form.apoderado' :id-perfil-usuario='idPerfilUsuario' :id-beca='idBeca'
        :es-becario='false' :es-misma-seccion='esApoderadoMismaSeccion' :es-doc-habilitado='esDocHabilitado'
        :es-apoderado-oblig='esApoderadoOblig' :hay-bec-o-apod='hayBecario' :es-bec-y-apod-iguales='esBecYApodIguales'
        :inicio-validar='validarApoderado.inicio' :inicio-guardar='guardarApoderado.inicio'
        :inicio-revertir='revertirApoderado.inicio' @act-hay-becario='actualizarHayBecOApod'
        @fin-validar='finValidarBecOApod' @fin-guardar='finGuardarBecOApod' @fin-revertir='finRevertirBecOApod'
        ref="panelApoderado" />
    </div>
    <div class="row mt-2 mb-1 actualizaBecas" v-show="verBeca">
      <fieldset class="col border pb-3">
        <legend class="w-auto" style="margin-top: -11px; background-color: white;">
          <b class="fs-5">Beca</b>
        </legend>
        <div class="row actualizaBecas mt-1">
          <div class="col-md-3">
            <label for="f_ingreso" class=" ">F. Inicio:</label>
            <input :disabled="!esHabilitadoModificar" required type="date" v-model="form.beca!.f_ingreso"
              class="form-control form-control-sm" autocomplete="off" id="f_ingreso" />
          </div>
          <div class="col-md-3">
            <label for="f_egreso" class=" ">F. Fin:</label>
            <input :disabled="/* !esHabilitadoModificar */ true" required type="date" v-model="form.beca!.f_egreso"
              class="form-control form-control-sm " autocomplete="off" id="f_egreso" />
          </div>
          <div class="col-md-3">
            <label for="importe" class="  d-block">Importe:</label>
            <!--
              <input :disabled="hayUltPeriodoLiq" required type="text" v-model="form.beca!.importe"              
                class="form-control form-control-sm" autocomplete="off" id="importe" />
              -->
            <input-currency v-model="form.importe" :options="inputCurrencyOptions" :class='"d-block p-0 px-2"'
              :disabled="!esHabilitadoModificar || hayUltPeriodoLiq" :required="true" :placeholder='"0,00"'
              :autocomplete='"off"' :id='"importe"' />
          </div>
          <div class="col-md-3" v-if="verLiqDetalle">
            <button type="button" class="btn btn-principal px-2 mt-1" alt="Ver per&iacute;odos liquidados de la beca"
              title="Ver per&iacute;odos liquidados de la beca" @click="abrirLiqDetalle">
              Ver per&iacute;odos liquidados
            </button>
            <Modal ref="liqDetalleModal" :size="'lg'" :title="liqDetalleTitulo">
              <LiqDetalleModal :id-beca="form.beca!.id_beca" @cerrar="cerrarLiqDetalle">
              </LiqDetalleModal>
            </Modal>
          </div>
          <!--
          <div class="col-md-3" v-if='hayUltPeriodoLiq'>
            <div class="d-md-flex align-items-end flex-wrap">
              <label for="ult_periodo_liq" class=" ">&Uacute;lt. Per&iacute;odo Liq.:</label>
              <input disabled type="date" v-model="form.beca!.ultimo_periodo_liqui" class="form-control form-control-sm"
                autocomplete="off" id="ult_periodo_liq" />
            </div>
          </div>          
          <div class="col-md-3">
            <div class="d-md-flex align-items-end flex-wrap">
              <label for="f_periodo" class=" ">F. Desde:</label>
              <input :disabled="hayUltPeriodoLiq" required type="date" v-model="form.beca!.f_periodo"
                class="form-control form-control-sm" autocomplete="off" id="f_periodo" />
            </div>
          </div>
        -->
        </div>
        <div class="row actualizaBecas mt-1">
          <div class="col-md-2">
            <label for="titulo" class=" ">T&iacute;tulo:</label>
            <select :disabled="!esHabilitadoModificar || hayUltPeriodoLiq" required v-model="form.titulo"
              class="form-select form-select-sm" id="titulo">
              <option :value="null" v-text="'--Seleccione--'"></option>
              <option v-for="titulo in titulosStore.getTitulos()" :key="titulo.id_titulo" :value="titulo"
                v-text="titulo.d_titulo">
              </option>
            </select>
          </div>
          <div class="col-md-3">
            <label for="establecimiento_cursa" class=" ">Cursa en:</label>
            <input :disabled="!esHabilitadoModificar || hayUltPeriodoLiq" required type="text"
              v-model="form.beca!.establecimiento_cursa" class="form-control form-control-sm" autocomplete="off"
              id="establecimiento_cursa" />
          </div>
          <div class="col-md-2">
            <label for="mes_certif" class=" ">Mes Certif.:</label>
            <select :disabled="!esHabilitadoModificar || hayUltPeriodoLiq" required v-model="form.mesCertif"
              class="form-select form-select-sm" id="mes_certif">
              <option :value="null" v-text="'--Seleccione--'"></option>
              <option v-for="mesCertif in rangoNumeros(3, 12)" :key="mesCertif" :value="mesCertif"
                v-text="mesMostrar(mesCertif)">
              </option>
            </select>
          </div>
          <div class="col-md-2">
            <label for="estado" class=" ">Estado:</label>
            <input disabled required type="text" v-model="form.beca!.d_estado"
              class="form-control form-control-sm p-0 px-2" autocomplete="off" id="estado" />
          </div>
          <div class="col-md-3" v-if='verVisado'>
            <div class="row mt-0">
              <div class="col-md-6">
                <label for="visado" class=" ">Visado:</label>
                <input disabled required type="text" v-model="form.beca!.d_visado"
                  class="form-control form-control-sm p-0 px-2" autocomplete="off" id="visado" />
              </div>
              <div class="col-md-6">
                <label :for='"fVisado"' class=" ">V&aacute;lido Desde:</label>
                <input disabled required type="date" v-model="form.beca!.f_visado" class="form-control form-control-sm"
                  autocomplete="off" :id="'fVisado'" />
              </div>
            </div>
          </div>
        </div>
      </fieldset>
    </div>
    <div class="row pb-3 actualizaBecas" v-show="verBapro">
      <fieldset class="col border">
        <legend class="w-auto" style="margin-top: -11px; background-color: white;">
          <b class="fs-5">Bapro</b>
        </legend>
        <div class="row pb-2">
          <div class="col-md-2 ">
            <b>Cobra por Bapro: </b>{{ form.beca?.d_cobra_bap }}
          </div>
          <div class="col-md-4 " v-show="verTitular">
            <b>Titular: </b>{{ descTitular }}
          </div>
          <div class="col-md-3" v-show="verSucursal">
            <b>Sucursal: </b>{{ descSucursal }}
          </div>
          <div class="col-md-3" v-show="verCbu">
            <b>CBU: </b>{{ form.beca?.cbu_completo }}
          </div>
        </div>
      </fieldset>
    </div>
  </div>
</template>

<script setup lang="ts">

// Librerias
import { DateTime } from "luxon";
import type { DurationUnits } from "luxon";
import { onMounted, reactive, computed, watch, ref, toRef, toRefs, nextTick } from "vue";
import type { PropType, Ref } from "vue";
import { CurrencyDisplay, ValueScaling } from "vue-currency-input";
import type { CurrencyInputOptions, NumberRange } from "vue-currency-input";
import { InputCurrency, Modal } from "@hcd-bsas/vue3-components";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions, SweetAlertResult } from "sweetalert2";
import http from "@/http";
import type { AxiosResponse, AxiosError } from "axios";
import { urlApi, isEmpty, loading } from "@/shared.js";
// Componentes
import CuposModal from "@/components/becas/actualizacion/cupos/Modal.vue";
import PanelBecario from "@/components/becas/actualizacion/abm/becario/Panel.vue";
import LiqDetalleModal from "@/components/becas/actualizacion/abm/liquidacion/detalle/Grilla.vue";
import VisadoModal from "@/components/becas/actualizacion/abm/visado/Panel.vue";
// Entidades
import { Usuariohabilitado } from "@/entities/Usuariohabilitado";
import Solicitante from "@/entities/Solicitante";
import Becario from "@/entities/becas/Becario";
import type Titulo from "@/entities/becas/Titulo";
import type BaproSucursal from "@/entities/becas/BaproSucursal";
import Beca from "@/entities/becas/Beca";
// Stores
import { useUsuariosStore } from "@/stores/usuarios";
import { usePermisosAppStore } from "@/stores/permisosApp";
import { usePeriodosStore } from "@/stores/periodos";
import { useSolicitantesStore } from "@/stores/solicitantes";
import { useBecariosStore } from "@/stores/becas/becarios";
import { useTiposDocStore } from "@/stores/becas/tiposDoc";
import { useGenerosStore } from "@/stores/becas/generos";
import { usePartidosStore } from "@/stores/becas/partidos";
import { useSeccionesStore } from "@/stores/becas/secciones";
import { useLocalidadesStore } from "@/stores/becas/localidades";
import { useTitulosStore } from "@/stores/becas/titulos";
import { useBaproSucursalesStore } from "@/stores/becas/baproSucursales";
import { useBecasStore } from "@/stores/becas/becas";

class Parametros {
  id_beca: number | null = null;
  id_tabla_sol: number | null = null;
  es_abm: number | null = null;
};
const props = defineProps({
  parametros: {
    type: Object as PropType<Parametros>,
    default: {},
    required: true,
  }
});

const emits = defineEmits(["cerrar"]);
const cargaBloquesInhabilitada = computed(() => periodosStore.periodos.activo?.carga_bloques_inhabilitada);
const usuarioActivoIdPerfil = computed(() => usuarioActivo.value?.id_perfil);
const rangoNumeros = (inicio: number, fin: number) => Array.from(Array(fin - inicio + 1).keys()).map((numero: number) => numero + inicio);
const importeMostrar = (importe: number | undefined) => (!isEmpty(importe)) ? Intl.NumberFormat("es-AR", { style: 'currency', currency: 'ARS', minimumFractionDigits: 2 }).format(importe!) : null;
const concatMostrar = (cadena_1: string, cadena_2: string, cadena_3: string) =>
  cadena_1.concat(!isEmpty(cadena_1) ? ' ' : '', cadena_2, !isEmpty(cadena_2) ? ' (' : '(', cadena_3, ')');
const fechaMostrar = (fecha: string | null | undefined) => (typeof fecha === "string") ? DateTime.fromISO(fecha).toFormat('dd/MM/yyyy') : "";
//const mesNumero = (fecha: string | null) => (fecha !== null) ? Number(DateTime.fromISO(fecha).toFormat('M')) : null;
const mesMostrar = (mes: number) => DateTime.fromObject({ month: mes }, { locale: 'es-AR' }).toFormat('MM (MMMM)');
const fechaEsMenor = (fecha_1: string, fecha_2: string) => DateTime.fromISO(fecha_1).startOf("day") < DateTime.fromISO(fecha_2).startOf("day");
const fechaEsMayor = (fecha_1: string, fecha_2: string) => DateTime.fromISO(fecha_1).startOf("month") > DateTime.fromISO(fecha_2).startOf("month");
const fechaUltDiaMes = (fecha: string) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha).endOf('month').toFormat('yyyy-MM-dd') : "";
const fechasDif = (f_minuendo: string, f_sustraendo: string, unidad: DurationUnits) => DateTime.fromISO(f_minuendo).diff(DateTime.fromISO(f_sustraendo), unidad).toObject();
const fechasDifAnios = (f_minuendo: string, f_sustraendo: string) => fechasDif(f_minuendo, f_sustraendo, 'years').years!;
const fechasDifMeses = (f_minuendo: string, f_sustraendo: string) => (!isEmpty(f_minuendo) && !isEmpty(f_sustraendo)) ? fechasDif(f_minuendo, f_sustraendo, 'months').months! : null;
const inputCurrencyOptions: CurrencyInputOptions = {
  // Se puede ver la lista de opciones en https://dm4t2.github.io/vue-currency-input/config.html
  accountingSign: false as boolean,
  autoDecimalDigits: false as boolean,
  currency: "ARS" as string,
  currencyDisplay: CurrencyDisplay.hidden as CurrencyDisplay,
  hideCurrencySymbolOnFocus: true as boolean,
  hideGroupingSeparatorOnFocus: true as boolean,
  hideNegligibleDecimalDigitsOnFocus: true as boolean,
  locale: "es-AR" as string,
  precision: {
    min: 2 as number | undefined,
    max: 2 as number | undefined
  } as NumberRange,
  useGrouping: true as boolean,
  valueRange: {
    min: 0.00 as number | undefined,
    max: 9999999999999.99 as number | undefined // Vue Currency Input solo admite un máximo de 15 dígitos para el valor de su campo "input"
  } as NumberRange,
  valueScaling: ValueScaling.precision as ValueScaling
};

const usuariosStore = useUsuariosStore();
const permisosAppStore = usePermisosAppStore();
const periodosStore = usePeriodosStore();
const solicitantesStore = useSolicitantesStore();
const becariosStore = useBecariosStore();
const tiposDocStore = useTiposDocStore();
const generosStore = useGenerosStore();
const partidosStore = usePartidosStore();
const seccionesStore = useSeccionesStore();
const localidadesStore = useLocalidadesStore();
const titulosStore = useTitulosStore();
const baproSucursalesStore = useBaproSucursalesStore();
const becasStore = useBecasStore();

const usuarioActivo = ref(null) as Ref<Usuariohabilitado | null>;
const idPerfilUsuario = computed(() => (!isEmpty(usuarioActivo.value)) ? usuarioActivo.value!.id_perfil : NaN);
const esAlta = computed(() => isEmpty(props.parametros.id_beca));
const idBeca = computed(() => (!esAlta.value) ? props.parametros.id_beca! : NaN);
const haySolicitanteBusq = computed(() => !isEmpty(props.parametros.id_tabla_sol));
const esOpcionAbm = computed(() => !isEmpty(props.parametros.es_abm) && props.parametros.es_abm === 1);
const esEstadoBaja = computed(() => (!esAlta.value) && (form.beca?.estado === "B"));
const haySolicitante = computed(() => !isEmpty(form.solicitante));
const hayUltPeriodoLiq = computed(() => !isEmpty(form.beca?.ultimo_periodo_liqui));
const hayPeriodoActivo = computed(() => !isEmpty(periodosStore.periodos.activo));
const haySucursal = computed(() => !isEmpty(form.beca?.baprosuc) && !isEmpty(form.beca?.d_baprosuc));
const hayCbu = computed(() => !isEmpty(form.beca?.cbu_completo));
const hayVisado = computed(() => !isEmpty(form.beca?.visado));
const esHabilitadoBloques = computed(() => hayPeriodoActivo.value ? !periodosStore.periodos.activo!.carga_bloques_inhabilitada : false);
const verBeca = computed(() => (!esAlta.value) || (esAlta.value && hayBecario.value));
const verLiqDetalle = computed(() => (esOpcionAbm.value) && (!esAlta.value) && (usuarioActivo.value?.id_perfil === 1));
const verVisado = computed(() => hayVisado.value);
const verBapro = computed(() => hayBecario.value);
const hayTitular = computed(() => (hayApelONomBecario.value && hayBaproSucBecario.value) || (hayApelONomApoderado.value && hayBaproSucApoderado.value));
const verTitular = computed(() => hayTitular.value);
const descTitular = computed(() =>
  verTitular.value ? (hayBaproSucApoderado.value ?
    concatMostrar(!isEmpty(form.apoderado.apellido) ? form.apoderado.apellido : "", !isEmpty(form.apoderado.nombres) ? form.apoderado.nombres : "", "Apoderado") :
    concatMostrar(!isEmpty(form.becario.apellido) ? form.becario.apellido : "", !isEmpty(form.becario.nombres) ? form.becario.nombres : "", "Becario")
  ) : ""
);
const verSucursal = computed(() => haySucursal.value);
const descSucursal = computed(() =>
  verSucursal.value ? (form.beca?.baprosuc + " - " + form.beca?.d_baprosuc) : ""
);
const verCbu = computed(() => hayCbu.value);
// const verModificar = computed(() => esOpcionAbm.value);
const verModificar = computed(() => ((esOpcionAbm.value) && (!esEstadoBaja.value) && ((esAlta.value) || (usuarioActivo.value?.id_perfil === 1) || ((usuarioActivo.value?.id_perfil === 3) && (esHabilitadoBloques.value) && (!hayVisado.value)))));
// const verEliminar = computed(() => (!esAlta.value) && (esOpcionAbm.value));
const verEliminar = computed(() => ((esOpcionAbm.value) && (!esEstadoBaja.value) && (usuarioActivo.value?.id_perfil === 1) || ((usuarioActivo.value?.id_perfil === 3) && (esHabilitadoBloques.value) && (!hayVisado.value))));
const esHabilitadoModificar = computed(() => ((esOpcionAbm.value) && (!esEstadoBaja.value) && ((esAlta.value) || (usuarioActivo.value?.id_perfil === 1) || ((usuarioActivo.value?.id_perfil === 3) && (esHabilitadoBloques.value) && (!hayVisado.value)))));
const esHabilitadoEliminar = computed(() => ((esOpcionAbm.value) && (!esEstadoBaja.value) && (usuarioActivo.value?.id_perfil === 1) || ((usuarioActivo.value?.id_perfil === 3) && (esHabilitadoBloques.value) && (!hayVisado.value))));
const esValidoEliminar = computed(() => !hayUltPeriodoLiq.value && !hayVisado.value);
const esOrigenEliminar = ref(false) as Ref<boolean>;
const fechaEgresoEliminar = computed(() => hayUltPeriodoLiq.value ? fechaUltDiaMes(form.beca!.ultimo_periodo_liqui) : form.beca?.f_ingreso);
const fechaEgreso = computed(() => (!esOrigenEliminar.value) ? form.beca?.f_egreso : fechaEgresoEliminar.value);
// const esFechasIngEgrIguales = computed(() => (form.beca?.f_ingreso === fechaEgreso.value));
const hayImporte = computed(() => !isEmpty(form.importe));
const esImporteValido = computed(() => (form.importe >= inputCurrencyOptions.valueRange!.min!) && (form.importe <= inputCurrencyOptions.valueRange!.max!));
const haySeccionSolicitante = computed(() => !isEmpty(form.solicitante?.id_seccion));
const haySolicTotalDisp = computed(() => haySolicitante.value ? ((form.solicitante!.tot_disponible > 0) ? true : false) : null);
const hayBecario = ref(false) as Ref<boolean>;
const hayApoderado = ref(false) as Ref<boolean>;
const hayApelONomBecario = computed(() => !isEmpty(form.becario.apellido) || !isEmpty(form.becario.nombres));
const hayNacimientoBecario = computed(() => !isEmpty(form.becario.f_nacimiento));
const haySeccionBecario = computed(() => !isEmpty(form.becario.id_seccion));
const hayBaproSucBecario = computed(() => !isEmpty(form.becario.baprosuc));
const hayCbuBecario = computed(() => !isEmpty(form.becario.cbu_completo));
const hayApelONomApoderado = computed(() => !isEmpty(form.apoderado.apellido) || !isEmpty(form.apoderado.nombres));
const haySeccionApoderado = computed(() => !isEmpty(form.apoderado.id_seccion));
const hayBaproSucApoderado = computed(() => !isEmpty(form.apoderado.baprosuc));
const hayCbuApoderado = computed(() => !isEmpty(form.apoderado.cbu_completo));
const esBecarioMismaSeccion = computed(() => (!haySeccionSolicitante.value) || (!haySeccionBecario.value) || (form.solicitante?.id_seccion === form.becario.id_seccion));
const esApoderadoMismaSeccion = computed(() => (!haySeccionSolicitante.value) || (!haySeccionApoderado.value) || (form.solicitante?.id_seccion === form.apoderado.id_seccion));
const esDocHabilitado = computed(() => ((esOpcionAbm.value) && (!esEstadoBaja.value) && (!hayUltPeriodoLiq.value) && (!hayCbu.value) && ((!hayVisado.value) || (hayVisado.value && usuarioActivo.value?.id_perfil === 1))));
const esApoderadoOblig = computed(() => (hayNacimientoBecario.value) && (fechasDifAnios(DateTime.now().toFormat('yyyy-MM-dd'), form.becario.f_nacimiento) < 18));
const esBecYApodIguales = computed(() =>
  (form.becario.tipo_doc === form.apoderado.tipo_doc) &&
  (String(form.becario.doc) === String(form.apoderado.doc)) &&
  (!isEmpty(form.becario.tipo_doc) && !isEmpty(form.becario.doc))
);

const form = reactive({
  solicitante: null as Solicitante | null,
  becario: new Becario() as Becario,
  apoderado: new Becario() as Becario,
  importe: NaN as number,
  titulo: null as Titulo | null,
  mesCertif: null as Number | null,
  beca: new Beca() as Beca | null
});

const validarBecario = reactive({
  inicio: false,
  fin: false
});
const validarApoderado = reactive({
  inicio: false,
  fin: false
});
const guardarBecario = reactive({
  inicio: false as boolean,
  fin: false as boolean,
  id: null as number | null
});
const guardarApoderado = reactive({
  inicio: false,
  fin: false,
  id: null as number | null
});
const revertirBecario = reactive({
  inicio: false,
  fin: false,
  id: null as number | null
});
const revertirApoderado = reactive({
  inicio: false,
  fin: false,
  id: null as number | null
});
const inicioValidarBeca = computed(() => validarBecario.fin && validarApoderado.fin);
//const inicioGuardarBecYApod = computed(() => validarBecario.fin && validarApoderado.fin);
const inicioGuardarBeca = computed(() => guardarBecario.fin && guardarApoderado.fin);
const inicioRevertirBeca = computed(() => revertirBecario.fin && revertirApoderado.fin);

const anioActivo = computed(() => String(periodosStore.periodos.activo?.anioActivo!));
const cuposModal = ref(Modal);
const liqDetalleModal = ref(Modal);
const visadoModal = ref(Modal);
const cuposTitulo = computed(() =>
  'Cupos del solicitante "' + form.solicitante?.ayn + '"' +
  ' desde el ' + fechaMostrar(anioActivo.value + '-03-01') +
  ' hasta el ' + fechaMostrar(anioActivo.value + '-12-31')
);
const cuposParametros = computed(() => ({
  f_cupo_des: anioActivo.value + '-03-01',
  f_cupo_has: anioActivo.value + '-12-31',
  id_tabla_sol: form.solicitante?.id_tabla_sol,
  usar_perfil_consulta: (usuarioActivo.value?.id_perfil_consulta === 2) ? 1 : 0
}));
const liqDetalleTitulo = computed(() =>
  'Liquidaciones de beca (Becario: ' +
  form.beca?.apellido_becario + ' ' + form.beca?.nombres_becario +
  ')'
);
const visadoTitulo = computed(() =>
  'Visado de beca (Becario: ' +
  form.beca?.apellido_becario + ' ' + form.beca?.nombres_becario +
  ')'
);

watch(hayBaproSucBecario, async (newValue, oldValue) => {
  let baproSucursal: BaproSucursal | null = null;
  let cbuCompleto: string | undefined = undefined;
  if ((newValue !== oldValue) && !(hayBaproSucApoderado.value || hayCbuApoderado.value)) {
    if (newValue || hayCbuBecario.value) {
      baproSucursal = (newValue) ? await baproSucursalesStore.findBaproSucursal(String(form.becario.baprosuc)) : null;
      cbuCompleto = form.becario.cbu_completo;
    }
    if (baproSucursal !== null) {
      form.beca!.baprosuc = baproSucursal!.c_bapro;
      form.beca!.d_baprosuc = baproSucursal!.d_bapro;
    } else {
      form.beca!.baprosuc = undefined;
      form.beca!.d_baprosuc = undefined;
    }
    form.beca!.cbu_completo = cbuCompleto;
  }
});
watch(hayCbuBecario, async (newValue, oldValue) => {
  let baproSucursal: BaproSucursal | null = null;
  let cbuCompleto: string | undefined = undefined;
  if ((newValue !== oldValue) && !(hayBaproSucApoderado.value || hayCbuApoderado.value)) {
    if (newValue || hayBaproSucBecario.value) {
      baproSucursal = (hayBaproSucBecario.value) ? await baproSucursalesStore.findBaproSucursal(String(form.becario.baprosuc)) : null;
      cbuCompleto = form.becario.cbu_completo;
    }
    if (baproSucursal !== null) {
      form.beca!.baprosuc = baproSucursal!.c_bapro;
      form.beca!.d_baprosuc = baproSucursal!.d_bapro;
    } else {
      form.beca!.baprosuc = undefined;
      form.beca!.d_baprosuc = undefined;
    }
    form.beca!.cbu_completo = cbuCompleto;
  }
});
watch(hayBaproSucApoderado, async (newValue, oldValue) => {
  let baproSucursal: BaproSucursal | null = null;
  let cbuCompleto: string | undefined = undefined;
  if (newValue !== oldValue) {
    if (newValue || hayCbuApoderado.value) {
      baproSucursal = (newValue) ? await baproSucursalesStore.findBaproSucursal(String(form.apoderado.baprosuc)) : null;
      cbuCompleto = form.apoderado.cbu_completo;
    } else if (hayBaproSucBecario.value || hayCbuBecario.value) {
      baproSucursal = (hayBaproSucBecario.value) ? await baproSucursalesStore.findBaproSucursal(String(form.becario.baprosuc)) : null;
      cbuCompleto = form.becario.cbu_completo;
    }
    if (baproSucursal !== null) {
      form.beca!.baprosuc = baproSucursal!.c_bapro;
      form.beca!.d_baprosuc = baproSucursal!.d_bapro;
    } else {
      form.beca!.baprosuc = undefined;
      form.beca!.d_baprosuc = undefined;
    }
    form.beca!.cbu_completo = cbuCompleto;
  }
});
watch(hayCbuApoderado, async (newValue, oldValue) => {
  let baproSucursal: BaproSucursal | null = null;
  let cbuCompleto: string | undefined = undefined;
  if (newValue !== oldValue) {
    if (newValue || hayBaproSucApoderado.value) {
      baproSucursal = (hayBaproSucApoderado.value) ? await baproSucursalesStore.findBaproSucursal(String(form.apoderado.baprosuc)) : null;
      cbuCompleto = form.apoderado.cbu_completo;
    } else if (hayCbuBecario.value || hayBaproSucBecario.value) {
      baproSucursal = (hayBaproSucBecario.value) ? await baproSucursalesStore.findBaproSucursal(String(form.becario.baprosuc)) : null;
      cbuCompleto = form.becario.cbu_completo;
    }
    if (baproSucursal !== null) {
      form.beca!.baprosuc = baproSucursal!.c_bapro;
      form.beca!.d_baprosuc = baproSucursal!.d_bapro;
    } else {
      form.beca!.baprosuc = undefined;
      form.beca!.d_baprosuc = undefined;
    }
    form.beca!.cbu_completo = cbuCompleto;
  }
});

watch(inicioValidarBeca, (newValue, oldValue) => {
  if (newValue !== oldValue && newValue) {
    validar();
  }
});
/*
watch(inicioGuardarBecYApod, (newValue, oldValue) => {
  if (newValue !== oldValue && newValue) {
    guardarBecarioYApoderado();
  }
});
*/
watch(inicioGuardarBeca, (newValue, oldValue) => {
  if (newValue !== oldValue && newValue) {
    agregarOEditar();
  }
});
watch(inicioRevertirBeca, (newValue, oldValue) => {
  if (newValue !== oldValue && newValue) {
    revertir();
  }
});

onMounted(async () => {
  loading.show();
  await cargar();
  //loading.hide();
});

async function cargar() {
  const idUsuarioActivo: string = permisosAppStore.currentUser!.id_usuario!;
  let promises: Promise<unknown>[] = [];
  let promiseUsuarioHab: Promise<Usuariohabilitado | null>;
  let promiseSolicitante: Promise<Solicitante | null>;
  let promiseBecario: Promise<Becario | null>;
  let promiseApoderado: Promise<Becario | null>;
  let promiseTitulo: Promise<Titulo | null>;
  let becario: Becario | null;
  let apoderado: Becario | null;
  if (isEmpty(tiposDocStore.getTiposDoc()) || isEmpty(generosStore.getGeneros()) || isEmpty(titulosStore.getTitulos()) ||
    isEmpty(partidosStore.getPartidos()) || isEmpty(seccionesStore.getSecciones()) || isEmpty(localidadesStore.getLocalidades())) {
    promises.push(tiposDocStore.fetchTiposDoc(), generosStore.fetchGeneros(), titulosStore.fetchTitulos(),
      partidosStore.fetchPartidos(), seccionesStore.fetchSecciones(), localidadesStore.fetchLocalidades());
  }
  if (esAlta.value && haySolicitanteBusq.value) {
    promiseUsuarioHab = usuariosStore.findUsuarioByIdUsuario(idUsuarioActivo);
    promiseSolicitante = solicitantesStore.findSolicitante(props.parametros.id_tabla_sol!);
    promises.push(promiseUsuarioHab, promiseSolicitante);
    await Promise.all(promises).then(async (values) => {
      usuarioActivo.value = await promiseUsuarioHab;
      //solicitantes = values.filter(value => value instanceof Solicitante);
      form.solicitante = await promiseSolicitante;
      //form.solicitante = (solicitantes.length === 1 && solicitantes[0] instanceof Solicitante) ? solicitantes[0] : null;  
      usuarioActivo.value!.id_perfil = Number(usuarioActivo.value?.id_perfil);
      usuarioActivo.value!.id_perfil_consulta = Number(usuarioActivo.value?.id_perfil_consulta);
      form.beca = new Beca();
      form.beca.f_ingreso = anioActivo.value + '-03-01';
      form.beca.f_egreso = anioActivo.value + '-12-31';
      form.beca.importe = NaN;
      form.beca.f_periodo = periodosStore.periodos.activo?.f_periodo!;
      //form.mesCertif = mesNumero(form.beca.f_periodo);
      form.beca.estado = 'A';
      form.beca.d_estado = 'Activo';
      form.beca.cobra_bap = 1;
      form.beca.d_cobra_bap = 'Sí';
      //form.becario = new Becario();
      //form.apoderado = new Becario();
      //loading.hide();
    }).catch(function () {
      //loading.hide();
    });
    loading.hide();
  } else if (!esAlta.value) {
    form.beca = await becasStore.findBeca(props.parametros.id_beca!);
    if (!isEmpty(form.beca)) {
      promiseUsuarioHab = usuariosStore.findUsuarioByIdUsuario(idUsuarioActivo);
      promiseSolicitante = solicitantesStore.findSolicitante(form.beca!.id_tabla_sol);
      //promiseBecario = becariosStore.findBecario(form.beca!.id_becario_beca);
      promiseBecario = becariosStore.findBecarioById({ id_becario: form.beca!.id_becario_beca, id_beca: form.beca!.id_beca });
      promises.push(promiseUsuarioHab, promiseSolicitante, promiseBecario);
      if (!isEmpty(form.beca!.id_becario_apod)) {
        //promiseApoderado = becariosStore.findBecario(form.beca!.id_becario_apod, false, false);
        promiseApoderado = becariosStore.findBecarioById({ id_becario: form.beca!.id_becario_apod, id_beca: form.beca!.id_beca }, false, false);
        promises.push(promiseApoderado);
      }
      if (!isEmpty(form.beca!.id_titulo)) {
        promiseTitulo = titulosStore.findTitulo(form.beca!.id_titulo);
        promises.push(promiseTitulo);
      }
      await Promise.all(promises).then(async (values) => {
        usuarioActivo.value = await promiseUsuarioHab;
        form.solicitante = await promiseSolicitante;
        becario = await promiseBecario;
        apoderado = promises.includes(promiseApoderado) ? (await promiseApoderado) : null;
        form.titulo = promises.includes(promiseTitulo) ? (await promiseTitulo) : null;
        usuarioActivo.value!.id_perfil = Number(usuarioActivo.value?.id_perfil);
        usuarioActivo.value!.id_perfil_consulta = Number(usuarioActivo.value?.id_perfil_consulta);
        form.becario = (becario !== null) ? Object.assign(new Becario(), becario) : form.becario;
        form.apoderado = (apoderado !== null) ? Object.assign(new Becario(), apoderado) : form.apoderado;
        form.importe = (!isEmpty(form.beca!.importe)) ? (form.beca!.importe * Math.pow(10, (<NumberRange>(inputCurrencyOptions.precision)).max!)) : NaN;
        form.mesCertif = (!isEmpty(form.beca!.mes_certif)) ? form.beca!.mes_certif : null;
        //loading.hide();
      }).catch(function () {
        loading.hide();
      });
    } else {
      loading.hide();
    }
  }
}

function verCupos() {
  cuposModal.value?.show();
}

function abrirLiqDetalle() {
  liqDetalleModal.value?.show();
}

function cerrarLiqDetalle() {
  liqDetalleModal.value?.hide();
}

function abrirVisado() {
  visadoModal.value?.show();
}

async function cerrarVisado(mensaje_out: string) {
  const swal_exito: SweetAlertOptions = {
    icon: "success",
    title: "&Eacute;xito",
    //html: "",
    html: mensaje_out,
    showConfirmButton: false,
    //timer: 500,
    timer: 1000,
  };
  visadoModal.value?.hide();
  //await nextTick();
  //cerrar();
  //await nextTick();
  //setTimeout(cerrar, 500);
  loading.hide();
  Swal.fire(swal_exito).then(function (result: SweetAlertResult<any>) {
    if (result.dismiss === Swal.DismissReason.timer) {
      //console.log("I was closed by the timer")
      cerrar();
    }
  });
}

async function exportar() {
  const params: any = {
    id_beca: form.beca!.id_beca,
    id_random: Math.floor(Math.random() * Number.MAX_SAFE_INTEGER)
  };
  const url: string = "exportBeca";
  const queryParams: string = "?id_beca=" + params.id_beca + "&" + "id_random=" + params.id_random;
  window.open(urlApi + url + queryParams, '_blank');
}

function actualizarHayBecOApod(parametros: { esBecario: boolean, hayBecario: boolean }) {
  if (parametros.esBecario) {
    hayBecario.value = parametros.hayBecario;
  } else {
    hayApoderado.value = parametros.hayBecario;
  }
}

function inicioValidar() {
  if (!hayUltPeriodoLiq.value && !esOrigenEliminar.value) {
    validarBecarioYApoderado();
  } else {
    validar();
  }
}

function validar() {
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  const fechaPeriodoMin: string = anioActivo.value + '-03-01';
  // const duracionBeca: number | null = fechasDifMeses(fechaEgreso.value!, form.beca!.f_ingreso);
  if (isEmpty(form.beca?.f_ingreso)) {
    swal.html = "Por favor, complete la fecha de inicio de la beca.";
  } else if (isEmpty(fechaEgreso.value)) {
    swal.html = "Por favor, complete la fecha de fin de la beca.";
    //} else if (isEmpty(form.beca?.importe)) {
  } else if (!hayImporte.value) {
    swal.html = "Por favor, complete el importe de la beca.";
  } else if (!esImporteValido.value) {
    swal.html = "Por favor, compruebe que el importe de la beca se sit&uacute;e entre " + String(inputCurrencyOptions.valueRange!.min) + " y " + String(inputCurrencyOptions.valueRange!.max) + "pesos.";
  } else if (isEmpty(form.beca?.f_periodo)) {
    //swal.html = 'Por favor, complete el campo "Fecha Desde" de la beca.';
    swal.html = 'El campo "Fecha Desde" de la beca no posee un valor v&aacute;lido. Por favor, avise al Administrador.';
  } else if (isEmpty(form.titulo)) {
    swal.html = 'Por favor, seleccione el t&iacute;tulo del becario, correspondiente al campo "T&iacute;tulo" de la beca.';
  } else if (isEmpty(form.beca?.establecimiento_cursa)) {
    swal.html = 'Por favor, complete el establecimiento en el que cursa el becario, correspondiente al campo "Cursa en" de la beca';
  } else if (isEmpty(form.mesCertif)) {
    swal.html = 'Por favor, seleccione el mes del certificado del becario, correspondiente al campo "Mes Certif." de la beca';
  } else if (hayUltPeriodoLiq.value && fechaEsMayor(form.beca!.f_ingreso, form.beca!.ultimo_periodo_liqui)) {
    swal.html = 'Por favor, compruebe que la fecha de inicio de la beca no sea posterior a aqu&eacute;lla correspondiente al &uacute;ltimo per&iacute;odo liquidado.';
  } /* else if ((!esFechasIngEgrIguales.value) && ((duracionBeca! < 3) || (duracionBeca! > 10))) {
    swal.html = 'Por favor, compruebe que la duraci&oacute;n de la beca (diferencia entre las fechas de inicio y fin) sea de entre tres y diez meses, o bien que las fechas de inicio y fin coincidan entre s&iacute;.';
  } */ else if (fechaEsMenor(form.beca!.f_periodo, fechaPeriodoMin)) {
    //swal.html = 'Por favor, compruebe que el campo "Fecha Desde" de la beca no sea anterior al d&iacute;a ' + fechaMostrar(fechaPeriodoMin) + '.';
    swal.html = 'El campo "Fecha Desde" de la beca no puede ser anterior al d&iacute;a ' + fechaMostrar(fechaPeriodoMin) + '. Por favor, avise al Administrador.';
  }
  if (!isEmpty(swal.html)) {
    esOrigenEliminar.value = false;
    Swal.fire(swal);
    return;
  }
  /*
  if (!hayUltPeriodoLiq.value && !esOrigenEliminar.value) {
    validarBecarioYApoderado();
  } else {
    noGuardarBecarioYApoderado();
  }
  */
  if (!hayUltPeriodoLiq.value && !esOrigenEliminar.value) {
    guardarBecarioYApoderado();
  } else {
    noGuardarBecarioYApoderado();
  }
}

function validarBecarioYApoderado() {
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  if (esBecYApodIguales.value && !isEmpty(form.becario.tipo_doc) && !isEmpty(form.becario.doc)) {
    swal.html = "Por favor, compruebe que el becario y el apoderado de la beca sean efectivamente personas distintas.";
  }
  if (!isEmpty(swal.html)) {
    Swal.fire(swal);
    return;
  }
  validarBecario.inicio = true;
  validarBecario.fin = false;
  validarApoderado.inicio = true;
  validarApoderado.fin = false;
}

function finValidarBecOApod(parametros: { esBecario: boolean, esExito: boolean }) {
  if (parametros.esBecario) {
    validarBecario.fin = parametros.esExito;
    validarBecario.inicio = false;
  } else {
    validarApoderado.fin = parametros.esExito;
    validarApoderado.inicio = false;
  }
}

function guardarBecarioYApoderado() {
  loading.show();
  guardarBecario.inicio = true;
  guardarBecario.fin = false;
  guardarBecario.id = null;
  guardarApoderado.inicio = true;
  guardarApoderado.fin = false;
  guardarApoderado.id = null;
}

function finGuardarBecOApod(parametros: { esBecario: boolean, esExito: boolean, idBecOApod: number | null }) {
  if (parametros.esBecario) {
    guardarBecario.id = parametros.idBecOApod;
    guardarBecario.fin = parametros.esExito;
    guardarBecario.inicio = false;
  } else {
    guardarApoderado.id = parametros.idBecOApod;
    guardarApoderado.fin = parametros.esExito;
    guardarApoderado.inicio = false;
  }
}

function revertirBecYOApod(esRevertirBecario: boolean, esRevertirApoderado: boolean) {
  if (esRevertirBecario) {
    revertirBecario.inicio = true;
    revertirBecario.fin = false;
    revertirBecario.id = guardarBecario.id;
  } else {
    revertirBecario.inicio = false;
    revertirBecario.fin = true;
    revertirBecario.id = null;
  }
  if (esRevertirApoderado) {
    revertirApoderado.inicio = true;
    revertirApoderado.fin = false;
    revertirApoderado.id = guardarApoderado.id;
  } else {
    revertirApoderado.inicio = false;
    revertirApoderado.fin = true;
    revertirApoderado.id = null;
  }
}

function finRevertirBecOApod(parametros: { esBecario: boolean, esExito: boolean, idBecOApod: number | null }) {
  if (parametros.esBecario) {
    revertirBecario.id = parametros.idBecOApod;
    revertirBecario.fin = parametros.esExito;
    revertirBecario.inicio = false;
  } else {
    revertirApoderado.id = parametros.idBecOApod;
    revertirApoderado.fin = parametros.esExito;
    revertirApoderado.inicio = false;
  }
}

function noGuardarBecarioYApoderado() {
  loading.show();
  //guardarBecario.inicio = false;
  //guardarBecario.fin = true;
  guardarBecario.id = form.beca!.id_becario_beca;
  //guardarApoderado.inicio = false;
  //guardarApoderado.fin = true;
  guardarApoderado.id = form.beca!.id_becario_apod;
  agregarOEditar();
}

function agregarOEditar() {
  const url: string = (esAlta.value) ? "addBeca" : "modifyBeca";
  const paramsRequest: any = {
    id_beca: form.beca?.id_beca,
    id_tabla_sol: form.solicitante?.id_tabla_sol,
    id_becario_beca: guardarBecario.id,
    id_becario_apod: guardarApoderado.id,
    f_ingreso: form.beca?.f_ingreso,
    f_egreso: fechaEgreso.value,
    importe: form.importe / Math.pow(10, (<NumberRange>(inputCurrencyOptions.precision)).max!),
    f_periodo: form.beca?.f_periodo,
    id_titulo: form.titulo?.id_titulo,
    establecimiento_cursa: form.beca?.establecimiento_cursa,
    mes_certif: form.mesCertif,
    cobra_bap: form.beca?.cobra_bap,
    estado: form.beca?.estado
  };
  esOrigenEliminar.value = false;
  guardar(url, paramsRequest);
}

function eliminarOEditar() {
  if (esValidoEliminar.value) {
    eliminar();
  } else {
    editarFechaEgreso();
  }
}

function editarFechaEgreso() {
  const swal: SweetAlertOptions = {
    icon: "question",
    title: "Confirmaci&oacute;n",
    /*
    html: 'No se encuentra permitida la eliminaci&oacute;n de la presente beca. &Uacute;nicamente se puede modificar su fecha de fin al d&iacute;a "' +
      fechaMostrar(fechaEgresoEliminar.value) + '". ¿Confirma esta operaci&oacute;n?',
      */
    html: 'La presente beca ser&aacute; dada de baja con fecha "' + fechaMostrar(fechaEgresoEliminar.value) + '". ¿Confirma esta operaci&oacute;n?',
    showCancelButton: true,
    confirmButtonColor: "#3085d6",
    cancelButtonColor: "#d33",
    confirmButtonText: "Confirmar",
    cancelButtonText: "Cancelar"
  };
  Swal.fire(swal).then(function (result: SweetAlertResult<any>) {
    if (result.isConfirmed) {
      esOrigenEliminar.value = true;
      inicioValidar();
    }
  });
}

function eliminar() {
  const url: string = "deleteBeca";
  const paramsRequest: any = {
    id_beca: form.beca?.id_beca,
    id_tabla_sol: form.solicitante?.id_tabla_sol,
    f_periodo: form.beca?.f_periodo
  };
  const swal: SweetAlertOptions = {
    icon: "question",
    title: "Confirmaci&oacute;n",
    html: "¿Confirma la eliminaci&oacute;n de la beca? ¡Esta acci&oacute;n no podr&aacute; ser revertida!",
    showCancelButton: true,
    confirmButtonColor: "#3085d6",
    cancelButtonColor: "#d33",
    confirmButtonText: "Confirmar",
    cancelButtonText: "Cancelar"
  };
  if (esValidoEliminar.value) {
    Swal.fire(swal).then(function (result: SweetAlertResult<any>) {
      if (result.isConfirmed) {
        loading.show();
        guardar(url, paramsRequest);
      }
    });
  }
}

async function guardar(url: string, paramsRequest: any) {
  const swal_exito: SweetAlertOptions = {
    icon: "success",
    title: "&Eacute;xito",
    html: "",
    showConfirmButton: false,
    timer: 500,
  };
  const swal_error: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  //loading.show();
  await http
    .post<any>(urlApi + url, paramsRequest)
    .then(function (response: AxiosResponse<any, any>) {
      form.beca!.id_beca = !isEmpty(response.data.id_out) ? Number(response.data.id_out) : response.data.id_out;
      swal_exito.html = response.data.mensaje_out;
      loading.hide();
      Swal.fire(swal_exito).then(function (result: SweetAlertResult<any>) {
        if (result.dismiss === Swal.DismissReason.timer) {
          //console.log("I was closed by the timer")
          cerrar();
        }
      });
    })
    .catch(function (error: AxiosError<string, any>) {
      if (error.response) {
        // Request made and server responded
        /*
        if (error.response.data.indexOf("|") !== -1) {
          swal_error.html = error.response.data.substring(
            error.response.data.indexOf("|") + 2,
            error.response.data.indexOf("Código") - 8
          );
        } else {
          swal_error.html =
            error.response.data.substring(
              error.response.data.indexOf("<h2>") + ("<h2>").length,
              error.response.data.indexOf("</h2>")
            );
        }
        */
        swal_error.html = error.response.data;
        console.log("Error: request made and server responded");
        console.log(swal_error.html);
        console.log(error.response);
        //console.log(error.response.status);
        //console.log(error.response.headers);
        //console.log(error.response.data);
      } else if (error.request) {
        // The request was made but no response was received
        swal_error.html =
          "Error desconocido. Por favor, avise al Administrador.";
        console.log("Error: the request was made but no response was received");
        console.log(error.request);
      } else {
        // Something happened in setting up the request that triggered an Error
        swal_error.html =
          "Error desconocido. Por favor, avise al Administrador.";
        console.log(
          "Error: something happened in setting up the request that triggered an error"
        );
        console.log(error);
      }
      loading.hide();
      //Swal.fire(swal_error);
      if (!isEmpty(form.becario.id_becario) && !isEmpty(form.apoderado.id_becario)) {
        Swal.fire(swal_error).then((result: SweetAlertResult<any>) => {
          /*
          if ((result.isConfirmed) && (
            (form.becario.id_becario !== guardarBecario.id!) ||
            (!(isEmpty(form.apoderado.id_becario) && isEmpty(guardarApoderado.id)) && (form.apoderado.id_becario !== guardarApoderado.id))
          )) {
*/
          if ((form.becario.id_becario !== guardarBecario.id!) ||
            (!(isEmpty(form.apoderado.id_becario) && isEmpty(guardarApoderado.id)) && (form.apoderado.id_becario !== guardarApoderado.id))
          ) {
            loading.show();
            form.becario.id_becario = guardarBecario.id!;
            form.apoderado.id_becario = guardarApoderado.id!;
          }

        });
      } else if ((isEmpty(form.becario.id_becario) && !isEmpty(guardarBecario.id)) || (isEmpty(form.apoderado.id_becario) && !isEmpty(guardarApoderado.id))) {
        swal_error.html += "<br>A continuaci&oacute;n, se proceder&aacute; a revertir el/las alta/s realizada/s del becario y/o apoderado asociado/s a esta beca.";
        /*
        swal_error.html += " ¿Desea revertir el/las alta/s realizada/s del becario y/o apoderado asociado/s a esta beca?";
        swal_error.showCancelButton = true;
        swal_error.confirmButtonColor = "#3085d6";
        swal_error.cancelButtonColor = "#d33";
        swal_error.confirmButtonText = "Confirmar";
        swal_error.cancelButtonText = "Cancelar";
        */
        Swal.fire(swal_error).then(function (result: SweetAlertResult<any>) {
          //if (result.isConfirmed) {
          loading.show();
          revertirBecYOApod((isEmpty(form.becario.id_becario) && !isEmpty(guardarBecario.id)), (isEmpty(form.apoderado.id_becario) && !isEmpty(guardarApoderado.id)));
          //guardar(url, paramsRequest);
          //}
        });
      } else {
        Swal.fire(swal_error);
      }
    });
}

function revertir() {
  const swal_exito: SweetAlertOptions = {
    icon: "success",
    title: "&Eacute;xito",
    html: "",
    showConfirmButton: false,
    timer: 500,
  };
  swal_exito.html = "Operaci&oacute;n/es exitosa/s";
  loading.hide();
  Swal.fire(swal_exito);
  /*
  Swal.fire(swal_exito).then(function (result: SweetAlertResult<any>) {
    if (result.dismiss === Swal.DismissReason.timer) {
      //console.log("I was closed by the timer")
      //cerrar();
      if (isEmpty(form.becario.id_becario)) {
        form.becario = new Becario();
      }
      if (isEmpty(form.apoderado.id_becario)) {
        form.apoderado = new Becario();
      }
    }
  });
  */
}

function cerrar() {
  emits("cerrar");
}

</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
